#include "B4RDefines.h"

namespace B4R {
	void B4RMCUFRIEND_kbv::Initialize(Byte CS, Byte RS, Byte WR, Byte RD, Byte RST) {
		ili = new (be) MCUFRIEND_kbv(CS, RS, WR, RD, RST);
		uint16_t g_identifier = ili->readID(); 
		if (g_identifier == 0x00D3 || g_identifier == 0xD3D3) g_identifier = 0x9481; // write-only shield
		if (g_identifier == 0xFFFF) g_identifier = 0x9341; // serial
		ili->begin(g_identifier);
		init();
	}
	void B4RMCUFRIEND_kbv::init() {
		gfx.gfx = ili;
		GFX = &gfx;
	}
	void B4RMCUFRIEND_kbv::FillScreen (UInt Color) {
		ili->fillScreen(Color);
	}
	UInt B4RMCUFRIEND_kbv::Color (Byte R, Byte G, Byte B) {
		return ili->color565(R, G, B);
	}
	void B4RMCUFRIEND_kbv::SetRotation(Byte b) {
		ili->setRotation(b);
	}
}